import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os
import shutil
import urllib2,urllib,uuid
import re
import extract
import downloader
import time
import sys,plugintools
import zipfile
import feedparser

USER_AGENT = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'
base='http://computergaragetvboxes.com'
ADDON=xbmcaddon.Addon(id='plugin.video.thefixer')

zip          =  ADDON.getSetting('zip')
dialog       =  xbmcgui.Dialog()
dp           =  xbmcgui.DialogProgress()
USERDATA     =  xbmc.translatePath(os.path.join('special://home/userdata',''))
ADDON_DATA   =  xbmc.translatePath(os.path.join(USERDATA,'addon_data'))
ADDONS       =  xbmc.translatePath(os.path.join('special://home','addons'))
GUI          =  xbmc.translatePath(os.path.join(USERDATA,'guisettings.xml'))
FAVS         =  xbmc.translatePath(os.path.join(USERDATA,'favourites.xml'))
SOURCE       =  xbmc.translatePath(os.path.join(USERDATA,'sources.xml'))
ADVANCED     =  xbmc.translatePath(os.path.join(USERDATA,'advancedsettings.xml'))
RSS          =  xbmc.translatePath(os.path.join(USERDATA,'RssFeeds.xml'))
KEYMAPS      =  xbmc.translatePath(os.path.join(USERDATA,'keymaps','keyboard.xml'))
USB          =  xbmc.translatePath(os.path.join(zip))
skin         =  xbmc.getSkinDir()
HOME         =  xbmc.translatePath('special://home/')
TribecaUrl   =  'http://tribeca.tvaddons.ag/'
thefixerpath  =  xbmc.translatePath(os.path.join('special://home','addons','plugin.video.thefixer'))
skinspath  =  xbmc.translatePath(os.path.join('special://home','addons','plugin.video.thefixer','resources','skins'))

thumbnailPath = xbmc.translatePath('special://thumbnails');
cachePath = os.path.join(xbmc.translatePath('special://home'), 'cache')
tempPath = xbmc.translatePath('special://temp')
addonPath = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'plugin.video.thefixer')
mediaPath = os.path.join(addonPath, 'media')
databasePath = xbmc.translatePath('special://database')
    
VERSION = "1.0.0"
PATH = "The Fixer"

#########################################################################################################################################################

AddonID='plugin.video.thefixer'; AddonTitle="Total Wipe"
EXCLUDES=  ['plugin.video.thefixer']

def _get_keyboard( default="", heading="", hidden=False ):
    """ shows a keyboard and returns a value """
    keyboard = xbmc.Keyboard( default, heading, hidden )
    keyboard.doModal()
    if ( keyboard.isConfirmed() ):
        return unicode( keyboard.getText(), "utf-8" )
    return default

def ARCHIVE_CB(sourcefile, destfile, message_header, message1, message2, message3, exclude_dirs, exclude_files):
    zipobj = zipfile.ZipFile(destfile , 'w', zipfile.ZIP_DEFLATED)
    rootlen = len(sourcefile)
    for_progress = []
    ITEM =[]
    dp.create(message_header, message1, message2, message3)
    for base, dirs, files in os.walk(sourcefile):
        for file in files:
            ITEM.append(file)
    N_ITEM =len(ITEM)
    for base, dirs, files in os.walk(sourcefile):
        dirs[:] = [d for d in dirs if d not in exclude_dirs]
        files[:] = [f for f in files if f not in exclude_files]
        for file in files:
            for_progress.append(file) 
            progress = len(for_progress) / float(N_ITEM) * 100  
            dp.update(int(progress),'[COLOR orange]%s[/COLOR]'%file, 'Please wait')
            fn = os.path.join(base, file)
            if not 'temp' in dirs:
                if not 'plugin.video.thefixer' in dirs:
                   import time
                   FORCE= '01/01/1980'
                   FILE_DATE=time.strftime('%d/%m/%Y', time.gmtime(os.path.getmtime(fn)))
                   if FILE_DATE > FORCE:
                       zipobj.write(fn, fn[rootlen:])  
    zipobj.close()
    dp.close()

def WipeKODI():
    choice = xbmcgui.Dialog().yesno("[COLOR red]Attention[/COLOR]", 'This will completely wipe your Kodi settings.', '[CR]Would you like to create a backup before proceeding?[CR]Backup.zip will be saved in the [COLOR aqua]plugin.video.thefixer[/COLOR] folder.', '', yeslabel='Yes',nolabel='No')
    if choice == 1:
        #mybackuppath = xbmc.translatePath(os.path.join(USB,'Backup','My Builds'))
        #if not os.path.exists(mybackuppath):
        #    os.makedirs(mybackuppath)
        #vq = _get_keyboard( heading="Enter a name for this backup" )
        #if ( not vq ): return False, 0
        title = urllib.quote_plus("backup")
        backup_zip = xbmc.translatePath(os.path.join(thefixerpath,title+'.zip'))
        exclude_dirs_full =  ['plugin.video.thefixer','Thumbnails']
        exclude_files_full = ["xbmc.log","xbmc.old.log","kodi.log","kodi.old.log",'.DS_Store','.setup_complete','XBMCHelper.conf','Textures13.db']
        message_header = "Creating backup... "
        message1 = "This will be saved in the[CR][COLOR aqua]plugin.video.thefixer[/COLOR]"
        message2 = ""
        message3 = ""
        ARCHIVE_CB(HOME, backup_zip, message_header, message1, message2, message3, exclude_dirs_full, exclude_files_full)
        dialog.ok('[COLOR orange]The Fixer[/COLOR]','Backup complete!','','')
            
    if skin!= "skin.confluence":
        dialog.ok('[COLOR red]Attention[/COLOR]','You must switch to the [COLOR aqua]Confluence skin[/COLOR] to wipe. ','Please change to Confluence and try wiping again.','')
        xbmc.executebuiltin("ActivateWindow(appearancesettings)")
        return
    else:
        choice2 = xbmcgui.Dialog().yesno("[COLOR red]Last chance to stop [/COLOR]", 'Are you absolutely certain about wiping your Kodi settings?', '', 'All addons and userdata will be gone!', yeslabel='Yes',nolabel='No')
        if choice2 == 0:
            return
        elif choice2 == 1:
            dp.create("[COLOR orange]The Fixer[/COLOR]","Wiping Kodi...",'', 'Please wait')
            try:
                for root, dirs, files in os.walk(HOME,topdown=True):
                    dirs[:] = [d for d in dirs if d not in EXCLUDES]
                    for name in files:
                        try:
                            os.remove(os.path.join(root,name))
                            os.rmdir(os.path.join(root,name))
                        except: pass
                            
                    for name in dirs:
                        try: os.rmdir(os.path.join(root,name)); os.rmdir(root)
                        except: pass
            except: pass
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        REMOVE_EMPTY_FOLDERS()
        dialog.ok('[COLOR orange]The Fixer[/COLOR]','The complete wipe is nearly done...','[COLOR yellow][CR]Please restart Kodi to finish the process.[/COLOR]','')

def REMOVE_EMPTY_FOLDERS():
    print"########### Start Removing Empty Folders #########"
    empty_count = 0
    used_count = 0
    for curdir, subdirs, files in os.walk(HOME):
        if len(subdirs) == 0 and len(files) == 0: #check for empty directories. len(files) == 0 may be overkill
            empty_count += 1 #increment empty_count
            os.rmdir(curdir) #delete the directory
            print "successfully removed: "+curdir
        elif len(subdirs) > 0 and len(files) > 0: #check for used directories
            used_count += 1 #increment used_count

def backup_tool():
    choice = xbmcgui.Dialog().yesno("[COLOR orange]The Fixer[/COLOR]", 'Would you like to create a backup?', 'Backup.zip will be saved in the [COLOR aqua]plugin.video.thefixer[/COLOR] folder.', '', yeslabel='Yes',nolabel='No')
    if choice == 1:
        title = urllib.quote_plus("backup")
        backup_zip = xbmc.translatePath(os.path.join(thefixerpath,title+'.zip'))
        exclude_dirs_full =  ['plugin.video.thefixer','Thumbnails']
        exclude_files_full = ["xbmc.log","xbmc.old.log","kodi.log","kodi.old.log",'.DS_Store','.setup_complete','XBMCHelper.conf','Textures13.db']
        message_header = "[COLOR orange]Creating backup... [/COLOR]"
        message1 = "This will be saved in the[CR][COLOR aqua]plugin.video.thefixer[/COLOR] folder. "
        message2 = ""
        message3 = ""
        ARCHIVE_CB(HOME, backup_zip, message_header, message1, message2, message3, exclude_dirs_full, exclude_files_full)
        dialog.ok('[COLOR orange]The Fixer[/COLOR]','Backup complete!','','')
    else:
        return

def Supportpopup():
    dialog.ok('[COLOR orange]Support info[/COLOR]','[COLOR red]Website: http://computergaragetvboxes.com[/COLOR]','[COLOR white]Email: Dylan@computergarage.ca[/COLOR][CR][COLOR blue]Twitter: @KawarthaHD[/COLOR]','[COLOR yellow]Cell: 705-933-4016[/COLOR]')


#########################################################################################################################################################
wipe_icon = xbmc.translatePath(os.path.join(skinspath,'wipe.png'))
support_icon = xbmc.translatePath(os.path.join(skinspath,'info.png'))
fanart_background = xbmc.translatePath(os.path.join(thefixerpath,'fanart.jpg'))
restore_icon = xbmc.translatePath(os.path.join(skinspath,'restore.png'))
backup_icon = xbmc.translatePath(os.path.join(skinspath,'backup.png'))
maint_icon = xbmc.translatePath(os.path.join(skinspath,'maint.png'))
clear_cache_icon = xbmc.translatePath(os.path.join(skinspath,'clear_cache.png'))
delete_thumbs_icon = xbmc.translatePath(os.path.join(skinspath,'delete_thumbnails.png'))
clear_packages_icon = xbmc.translatePath(os.path.join(skinspath,'clear_packages.png'))
    
def CATEGORIES():
    link = OPEN_URL('https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1').replace('\n','').replace('\r','')
    match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
    for name,url,iconimage,fanart,description in match:
        addDir(name,url,1,iconimage,fanart,description)
    addDir('Backup','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',5,backup_icon,fanart_background,'Backup your current build .')
    addDir('Complete wipe','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',2,wipe_icon,fanart_background,'Completely wipe all addons and userdata.')
    addDir('Restore backup','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',4,restore_icon,fanart_background,'Restore a previous backup.')
    addDir2('Maintenance','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',6,maint_icon,fanart_background,'Support info from your TV box seller. ')
    addDir('Support info','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',3,support_icon,fanart_background,'Support info from your TV box seller. ')
    setView('movies', 'MAIN')

def MAINTENANCE():
    addItem('Clear Cache','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',9,clear_cache_icon,fanart_background,'Completely wipe all addons and userdata.')
    addItem('Delete Thumbnails','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',8,delete_thumbs_icon,fanart_background,'Restore a previous backup.')
    addItem('Clear Packages','https://www.dropbox.com/s/gvgm0aid4qls8yo/wizard.txt?dl=1',7,clear_packages_icon,fanart_background,'Backup your current build .')
    setView('movies', 'MAIN')

###########################################################################################################################################################

class cacheEntry:
    def __init__(self, namei, pathi):
        self.name = namei
        self.path = pathi

def setupCacheEntries():
    entries = 5 #make sure this refelcts the amount of entries you have
    dialogName = ["WTF", "4oD", "BBC iPlayer", "Simple Downloader", "ITV"]
    pathName = ["special://profile/addon_data/plugin.video.whatthefurk/cache", "special://profile/addon_data/plugin.video.4od/cache",
					"special://profile/addon_data/plugin.video.iplayer/iplayer_http_cache","special://profile/addon_data/script.module.simple.downloader",
                    "special://profile/addon_data/plugin.video.itv/Images"]
                    
    cacheEntries = []
    
    for x in range(entries):
        cacheEntries.append(cacheEntry(dialogName[x],pathName[x]))
    
    return cacheEntries

def clearCache():    
    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("[COLOR red]Delete Kodi Cache Files[/COLOR]", str(file_count) + " files found.", "Do you want to delete them?"):
                
                    for f in files:
                        try:
                            if (f == "xbmc.log" or f == "xbmc.old.log"): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                else:
                    return
                        
            else:
                pass
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                dialog = xbmcgui.Dialog()
                if dialog.yesno("[COLOR red]Delete Kodi Cache Files[/COLOR]", str(file_count) + " files found.", "Do you want to delete them?"):
                    for f in files:
                        try:
                            if (f == "xbmc.log" or f == "xbmc.old.log"): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                else:
                    return
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'Other'", "Do you want to delete them?"):
                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                else:
                    return
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'LocalAndRental'", "Do you want to delete them?"):
                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                else:
                    return
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:

                    dialog = xbmcgui.Dialog()
                    if dialog.yesno("[COLOR orange]The Fixer[/COLOR]",str(file_count) + "%s cache files found"%(entry.name), "Do you want to delete them?"):
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                    else:
                        return
                            
                else:
                    pass
                

    dialog = xbmcgui.Dialog()
    dialog.ok("[COLOR orange]The Fixer[/COLOR]", "Clear Cache Files Done")

def deleteThumbnails():
    if os.path.exists(thumbnailPath)==True:  
            dialog = xbmcgui.Dialog()
            if dialog.yesno("[COLOR red]Delete Thumbnails[/COLOR]", "[COLOR yellow]This option will delete all thumbnails.[/COLOR]", "Are you sure you want to do this?"):
                for root, dirs, files in os.walk(thumbnailPath):
                    file_count = 0
                    file_count += len(files)
                    if file_count > 0:                
                        for f in files:
                            try:
                                os.unlink(os.path.join(root, f))
                            except:
                                pass
            else:
                return
    else:
        pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    os.unlink(text13)
        
    dialog.ok("[COLOR red]Restart Kodi[/COLOR]", "Please restart Kodi to rebuild thumbnail library.")
        
def purgePackages():
    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    if dialog.yesno("[COLOR red]Delete Package Files[/COLOR]", "%d packages found."%file_count, "Do you want to delete them?"):  
        for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))
                dialog = xbmcgui.Dialog()
                dialog.ok("[COLOR orange]The Fixer[/COLOR]", "Delete Package Files Done")
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok("[COLOR orange]The Fixer[/COLOR]", "No Packages to Purge")
    else:
        return



######################################################################################################################################################
    
def OPEN_URL(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link
      
def wizard(name,url,description):
    path = xbmc.translatePath(os.path.join('special://home/addons','packages'))
    dp = xbmcgui.DialogProgress()
    dp.create("[COLOR orange]The Fixer[/COLOR]","Downloading... ",'', 'Please wait')
    lib=os.path.join(path, name+'.zip')
    try:
       os.remove(lib)
    except:
       pass
    downloader.download(url, lib, dp)
    addonfolder = xbmc.translatePath(os.path.join('special://','home'))
    #READ_ZIP(lib)
    time.sleep(2)
    dp.update(0,"", "Installing...")
    print '======================================='
    print addonfolder
    print '======================================='
    extract.all(lib,addonfolder,dp)
    dp.update(0,"", "Finishing up...")
    time.sleep(5)
    #xbmc.executebuiltin('UnloadSkin()')
    #time.sleep(2)
    #xbmc.executebuiltin('ReloadSkin()')
    #time.sleep(2)
    dialog = xbmcgui.Dialog()
    dialog.ok("[COLOR red]Attention[/COLOR]", "[COLOR yellow]Installation nearly complete but the next step is critical. [/COLOR]")
    dialog = xbmcgui.Dialog()
    dialog.ok("[COLOR red]Attention[/COLOR]", "[COLOR yellow]You must unplug your device immediately and then [CR]reboot in order for the setup to be properly completed. [/COLOR]", "[COLOR white][CR]Any other action will cause problems with your installation. [/COLOR]")
#    dialog = xbmcgui.Dialog()
#    dialog.ok("[COLOR orange]The Fixer[/COLOR]", "[COLOR red]Please Click Yes to restart Kodi[/COLOR]")

#    choice = xbmcgui.Dialog().yesno("[COLOR red]Please Click Restart to restart Kodi App![/COLOR]", '[COLOR red]Click Reboot to reboot your system![/COLOR]', '', 'Reboot if your on Android or Openlec boxes!', yeslabel='Restart',nolabel='Reboot')
#    if choice == 0:
#        xbmc.executebuiltin('Reboot')
#    elif choice == 1:
#        xbmc.executebuiltin('Skin.Theme')
       
    '''if xbmc.getCondVisibility("System.Platform.Android"):
        xbmc.executebuiltin('Reboot')
    elif xbmc.getCondVisibility("System.Platform.Linux.RaspberryPi"):
        xbmc.executebuiltin('Reboot')
    elif xbmc.getCondVisibility("System.Platform.Linux"):
        xbmc.executebuiltin('Reboot')
    elif xbmc.getCondVisibility("System.Platform.Windows"):
        xbmc.executebuiltin('RestartApp')
    elif xbmc.getCondVisibility("System.Platform.OSX"):
        xbmc.executebuiltin('RestartApp')
    elif xbmc.getCondVisibility("System.Platform.ISO"):
        xbmc.executebuiltin('RestartApp')'''
    
def READ_ZIP(url):

    import zipfile
    
    z = zipfile.ZipFile(url, "r")
    for filename in z.namelist():
        if 'guisettings.xml' in filename:
            a = z.read(filename)
            r='<setting type="(.+?)" name="%s.(.+?)">(.+?)</setting>'% skin
            
            match=re.compile(r).findall(a)
            print match
            for type,string,setting in match:
                setting=setting.replace('&quot;','') .replace('&amp;','&') 
                xbmc.executebuiltin("Skin.Set%s(%s,%s)"%(type.title(),string,setting))  
                
        if 'favourites.xml' in filename:
            a = z.read(filename)
            f = open(FAVS, mode='w')
            f.write(a)
            f.close()  
			               
        if 'sources.xml' in filename:
            a = z.read(filename)
            f = open(SOURCE, mode='w')
            f.write(a)
            f.close()    
                         
        if 'advancedsettings.xml' in filename:
            a = z.read(filename)
            f = open(ADVANCED, mode='w')
            f.write(a)
            f.close()                 

        if 'RssFeeds.xml' in filename:
            a = z.read(filename)
            f = open(RSS, mode='w')
            f.write(a)
            f.close()                 
            
        if 'keyboard.xml' in filename:
            a = z.read(filename)
            f = open(KEYMAPS, mode='w')
            f.write(a)
            f.close()

def RESTORE():

    import time
        
    try:
        dp = xbmcgui.DialogProgress()
        dp.create("[COLOR orange]The Fixer[/COLOR]","Locating previous backup... ",'', 'Please wait')
        lib=xbmc.translatePath(os.path.join(thefixerpath,'backup.zip'))
        #dialog = xbmcgui.Dialog()
        #dialog.ok('[COLOR orange]The Fixer[/COLOR]','Press Ok to Restore your build.','','')
        addonfolder = xbmc.translatePath(os.path.join('special://','home'))
        time.sleep(2)
        dp.update(0,"", "Installing...")
        extract.all(lib,addonfolder,dp)
        dp.update(0,"", "Finishing up...")
        time.sleep(5)
        dialog = xbmcgui.Dialog()
        dialog.ok("[COLOR red]Attention[/COLOR]", "[COLOR yellow]Installation nearly complete but the next step is critical. [/COLOR]")
        dialog = xbmcgui.Dialog()
        dialog.ok("[COLOR red]Attention[/COLOR]", "[COLOR yellow]You must unplug your device immediately and then [CR]reboot in order for the setup to be properly completed. [/COLOR]", "[COLOR white][CR]Any other action will cause problems with your installation. [/COLOR]")
        
        '''
        dialog = xbmcgui.Dialog()
        dialog.ok("[COLOR orange]The Fixer[/COLOR]", "[COLOR yellow]Installation nearly complete but one important step remains. [/COLOR]")
        dialog = xbmcgui.Dialog()
        dialog.ok("[COLOR orange]The Fixer[/COLOR]", "[COLOR red]Please Click OK to restart Kodi[/COLOR]")
        if xbmc.getCondVisibility('System.Platform.Windows') or xbmc.getCondVisibility('System.Platform.OSX'):
            xbmc.executebuiltin('RestartApp')
        else:
            xbmc.executebuiltin('Reset')'''
    except:
        dialog = xbmcgui.Dialog()
        dialog.ok('[COLOR orange]The Fixer[/COLOR]','Backup.zip is missing from the [COLOR aqua]plugin.video.thefixer[/COLOR] folder.[CR]You need to make a backup first.','','')



def addDir(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok
    
def addDir2(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok

def addItem(name,url,mode,iconimage,fanart,description):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&fanart="+urllib.quote_plus(fanart)+"&description="+urllib.quote_plus(description)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name, "Plot": description } )
        liz.setProperty( "Fanart_Image", fanart )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok
        
       
        
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param
        
                      
params=get_params()
url=None
name=None
mode=None
iconimage=None
fanart=None
description=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:        
        mode=int(params["mode"])
except:
        pass
try:        
        fanart=urllib.unquote_plus(params["fanart"])
except:
        pass
try:        
        description=urllib.unquote_plus(params["description"])
except:
        pass
        
        
print str(PATH)+': '+str(VERSION)
print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "IconImage: "+str(iconimage)


def setView(content, viewType):
    # set content type so library shows more views and info
    if content:
        xbmcplugin.setContent(int(sys.argv[1]), content)
    if ADDON.getSetting('auto-view')=='true':
        xbmc.executebuiltin("Container.SetViewMode(%s)" % ADDON.getSetting(viewType) )
        
        
if mode==None or url==None or len(url)<1:
        CATEGORIES()
       
elif mode==1:
        wizard(name,url,description)

elif mode==2:
        WipeKODI()

elif mode==3:
        Supportpopup()

elif mode==4:
        RESTORE()

elif mode==5:
        backup_tool()

elif mode==6:
        MAINTENANCE()

elif mode==7:
        purgePackages()

elif mode==8:
        deleteThumbnails()

elif mode==9:
        clearCache()
        

        
xbmcplugin.endOfDirectory(int(sys.argv[1]))

